/**
 * Copyright (c) 2021, WSO2 Inc. (http://www.wso2.com). All Rights Reserved.
 *
 * This software is the property of WSO2 Inc. and its suppliers, if any.
 * Dissemination of any information or reproduction of any material contained
 * herein in any form is strictly forbidden, unless permitted by WSO2 expressly.
 * You may not alter or remove any copyright or other notice from copies of this content."
 */

export const hiddenPermissions: string[] = [
    "/permission/applications",
    "/permission/protected",
    "/permission/protected/configure",
    "/permission/protected/configure/components",
    "/permission/protected/manage",
    "/permission/protected/manage/modify",
    "/permission/protected/manage/modify/tenants",
    "/permission/protected/manage/monitor",
    "/permission/protected/manage/monitor/tenants",
    "/permission/protected/manage/monitor/tenants/list",
    "/permission/protected/server-admin",
    "/permission/protected/server-admin/homepage",
    "/permission/protected/server-admin/jmx",
    "/permission/protected/server-admin/jmx/readonly",
    "/permission/protected/server-admin/jmx/readwrite",
    "/permission/admin/monitor",
    "/permission/admin/monitor/metrics",
    "/permission/admin/monitor/bpel",
    "/permission/admin/monitor/attachment",
    "/permission/admin/configure",
    "/permission/admin/configure/security",
    "/permission/admin/configure/security/usermgt",
    "/permission/admin/configure/security/usermgt/passwords",
    "/permission/admin/configure/security/usermgt/profiles",
    "/permission/admin/configure/security/usermgt/users",
    "/permission/admin/configure/security/usermgt/provisioning",
    "/permission/admin/configure/datasources",
    "/permission/admin/configure/remotefetch",
    "/permission/admin/configure/theme",
    "/permission/admin/manage/search",
    "/permission/admin/manage/search/advanced-search",
    "/permission/admin/manage/search/resources",
    "/permission/admin/manage/attachment",
    "/permission/admin/manage/extensions",
    "/permission/admin/manage/extensions/add",
    "/permission/admin/manage/extensions/list",
    "/permission/admin/manage/topic",
    "/permission/admin/manage/topic/deleteTopic",
    "/permission/admin/manage/topic/browseTopic",
    "/permission/admin/manage/topic/purgeTopic",
    "/permission/admin/manage/topic/addTopic",
    "/permission/admin/manage/humantask",
    "/permission/admin/manage/humantask/packages",
    "/permission/admin/manage/humantask/viewtasks",
    "/permission/admin/manage/humantask/add",
    "/permission/admin/manage/humantask/task",
    "/permission/admin/manage/event-streams",
    "/permission/admin/manage/bpel",
    "/permission/admin/manage/bpel/instances",
    "/permission/admin/manage/bpel/processes",
    "/permission/admin/manage/bpel/packages",
    "/permission/admin/manage/bpel/add",
    "/permission/admin/manage/resources",
    "/permission/admin/manage/resources/browse",
    "/permission/admin/manage/resources/notifications",
    "/permission/admin/manage/add",
    "/permission/admin/manage/add/webapp",
    "/permission/admin/manage/identity/pep",
    "/permission/admin/manage/identity/template",
    "/permission/admin/manage/identity/template/mgt",
    "/permission/admin/manage/identity/template/mgt/view",
    "/permission/admin/manage/identity/template/mgt/add",
    "/permission/admin/manage/identity/template/mgt/delete",
    "/permission/admin/manage/identity/template/mgt/list",
    "/permission/admin/manage/identity/consentmgt",
    "/permission/admin/manage/identity/consentmgt/list",
    "/permission/admin/manage/identity/consentmgt/view",
    "/permission/admin/manage/identity/consentmgt/add",
    "/permission/admin/manage/identity/consentmgt/delete",
    "/permission/admin/manage/identity/apptemplatemgt",
    "/permission/admin/manage/identity/apptemplatemgt/view",
    "/permission/admin/manage/identity/apptemplatemgt/update",
    "/permission/admin/manage/identity/apptemplatemgt/delete",
    "/permission/admin/manage/identity/apptemplatemgt/create",
    "/permission/admin/manage/identity/identitymgt",
    "/permission/admin/manage/identity/identitymgt/view",
    "/permission/admin/manage/identity/identitymgt/update",
    "/permission/admin/manage/identity/identitymgt/create",
    "/permission/admin/manage/identity/identitymgt/delete",
    "/permission/admin/manage/identity/userprofile",
    "/permission/admin/manage/identity/userprofile/view",
    "/permission/admin/manage/identity/userprofile/create",
    "/permission/admin/manage/identity/userprofile/delete",
    "/permission/admin/manage/identity/userprofile/update",
    "/permission/admin/manage/event-publish",
    "/permission/admin/manage/cors",
    "/permission/admin/manage/cors/origins",
    "/permission/admin/manage/cors/origins/view",
    "/permission/admin/manage/modify",
    "/permission/admin/manage/modify/webapp",
    "/permission/admin/manage/modify/user-profile",
    "/permission/admin/manage/identity/workflow",
    "/permission/admin/manage/identity/workflow/association",
    "/permission/admin/manage/identity/workflow/association/view",
    "/permission/admin/manage/identity/workflow/association/delete",
    "/permission/admin/manage/identity/workflow/association/create",
    "/permission/admin/manage/identity/workflow/association/update",
    "/permission/admin/manage/identity/workflow/definition",
    "/permission/admin/manage/identity/workflow/definition/create",
    "/permission/admin/manage/identity/workflow/definition/delete",
    "/permission/admin/manage/identity/workflow/definition/view",
    "/permission/admin/manage/identity/workflow/definition/update",
    "/permission/admin/manage/identity/workflow/profile",
    "/permission/admin/manage/identity/workflow/profile/view",
    "/permission/admin/manage/identity/workflow/profile/create",
    "/permission/admin/manage/identity/workflow/profile/delete",
    "/permission/admin/manage/identity/workflow/profile/update",
    "/permission/admin/manage/identity/workflow/monitor",
    "/permission/admin/manage/identity/workflow/monitor/view",
    "/permission/admin/manage/identity/workflow/monitor/delete",
    "/permission/admin/manage/identity/emailmgt",
    "/permission/admin/manage/identity/emailmgt/update",
    "/permission/admin/manage/identity/emailmgt/create",
    "/permission/admin/manage/identity/emailmgt/delete",
    "/permission/admin/manage/identity/emailmgt/view",
    "/permission/admin/manage/identity/provisioning",
    "/permission/admin/manage/identity/user",
    "/permission/admin/manage/identity/user/association",
    "/permission/admin/manage/identity/user/association/view",
    "/permission/admin/manage/identity/user/association/update",
    "/permission/admin/manage/identity/user/association/delete",
    "/permission/admin/manage/identity/user/association/create",
    "/permission/admin/manage/identity/userstore",
    "/permission/admin/manage/identity/userstore/count",
    "/permission/admin/manage/identity/userstore/count/delete",
    "/permission/admin/manage/identity/userstore/count/view",
    "/permission/admin/manage/identity/userstore/count/create",
    "/permission/admin/manage/identity/userstore/count/update",
    "/permission/admin/manage/identity/userstore/config",
    "/permission/admin/manage/identity/userstore/config/delete",
    "/permission/admin/manage/identity/userstore/config/create",
    "/permission/admin/manage/identity/userstore/config/update",
    "/permission/admin/manage/identity/userstore/config/view",
    "/permission/admin/manage/identity/functionsLibrarymgt",
    "/permission/admin/manage/identity/functionsLibrarymgt/update",
    "/permission/admin/manage/identity/functionsLibrarymgt/create",
    "/permission/admin/manage/identity/functionsLibrarymgt/delete",
    "/permission/admin/manage/identity/functionsLibrarymgt/view",
    "/permission/admin/manage/identity/userroleuimgt",
    "/permission/admin/manage/identity/userroleuimgt/create",
    "/permission/admin/manage/identity/defaultauthSeq",
    "/permission/admin/manage/identity/defaultauthSeq/view",
    "/permission/admin/manage/identity/defaultauthSeq/update",
    "/permission/admin/manage/identity/defaultauthSeq/create",
    "/permission/admin/manage/identity/defaultauthSeq/delete",
    "/permission/admin/manage/identity/entitlement",
    "/permission/admin/manage/identity/entitlement/pap",
    "/permission/admin/manage/identity/entitlement/pap/policy",
    "/permission/admin/manage/identity/entitlement/pap/policy/delete",
    "/permission/admin/manage/identity/entitlement/pap/policy/publish",
    "/permission/admin/manage/identity/entitlement/pap/policy/create",
    "/permission/admin/manage/identity/entitlement/pap/policy/view",
    "/permission/admin/manage/identity/entitlement/pap/policy/rollback",
    "/permission/admin/manage/identity/entitlement/pap/policy/order",
    "/permission/admin/manage/identity/entitlement/pap/policy/demote",
    "/permission/admin/manage/identity/entitlement/pap/policy/update",
    "/permission/admin/manage/identity/entitlement/pap/policy/enable",
    "/permission/admin/manage/identity/entitlement/pap/policy/list",
    "/permission/admin/manage/identity/entitlement/pap/subscriber",
    "/permission/admin/manage/identity/entitlement/pap/subscriber/update",
    "/permission/admin/manage/identity/entitlement/pap/subscriber/view",
    "/permission/admin/manage/identity/entitlement/pap/subscriber/list",
    "/permission/admin/manage/identity/entitlement/pap/subscriber/create",
    "/permission/admin/manage/identity/entitlement/pap/subscriber/delete",
    "/permission/admin/manage/identity/entitlement/pdp",
    "/permission/admin/manage/identity/entitlement/pdp/view",
    "/permission/admin/manage/identity/entitlement/pdp/manage",
    "/permission/admin/manage/identity/entitlement/pdp/test",
    "/permission/admin/manage/identity/entitlement/pep",
    "/permission/admin/manage/identity/challenge",
    "/permission/admin/manage/identity/challenge/delete",
    "/permission/admin/manage/identity/challenge/create",
    "/permission/admin/manage/identity/challenge/update",
    "/permission/admin/manage/identity/challenge/view"
];
